<?php
// Clean start of the TreasurySystem
class TreasurySystem extends DBfunctions
{

function getOrders()
{
$queryString = "SELECT DISTINCT ".ROSTER_ADDON_ORDERSTABLE.".*, ".ROSTER_MEMBERSTABLE.".member_id, ".ROSTER_MEMBERSTABLE.".name FROM ".ROSTER_ADDON_ORDERSTABLE.", ".ROSTER_ITEMSTABLE.", ".ROSTER_MEMBERSTABLE." WHERE (".ROSTER_ITEMSTABLE.".item_name = ".ROSTER_ADDON_ORDERSTABLE.".item_name) AND (".ROSTER_ITEMSTABLE.".member_id = ".ROSTER_ADDON_ORDERSTABLE.".treasurer_id) AND (".ROSTER_ADDON_ORDERSTABLE.".member_id = ".ROSTER_MEMBERSTABLE.".member_id) ORDER BY ".ROSTER_ADDON_ORDERSTABLE.".treasurer_id";
$query = $this->query($queryString);
$counter = $this->getCount($query);
	for($i=1; $i<=$counter; $i++)
	{
		$orders[$i]= $this->getrow($query);
	}
$_SESSION['orders'] = $orders;
$_SESSION['counter'] = $counter;
}


function loopOrders($comparison, $action, $ordersTextKey, $ordersKey)
{
	if($action=="truth")
	{
		foreach($_SESSION['orders'][$ordersKey] as $key => $value)
		{
			if(($key == $ordersTextKey) and ($comparison==$value))
			{
				return true;
			}
		}
		
	} elseif($action=="response") {
		for ($i=0; $i<=$_SESSION['counter']; $i++)
		{
			if($comparison==stripslashes($_SESSION['orders'][$i][$ordersTextKey])&&$ordersKey==$_SESSION['orders'][$i]['treasurer_id'])
			{
				return $i;
			}
		}
	} elseif($action=="identify") {
		$queryString = "SELECT ".ROSTER_ADDON_ORDERSTABLE.".*, ".ROSTER_MEMBERSTABLE.".name FROM ".ROSTER_ADDON_ORDERSTABLE.", ".ROSTER_MEMBERSTABLE." WHERE ('".$this->escape($comparison)."' = ".ROSTER_ADDON_ORDERSTABLE.".item_name) AND (".ROSTER_ADDON_ORDERSTABLE.".member_id = ".ROSTER_MEMBERSTABLE.".member_id) AND (".ROSTER_ADDON_ORDERSTABLE.".treasurer_id =".$ordersTextKey.") AND (".ROSTER_ADDON_ORDERSTABLE.".treasurer_id =".$ordersKey.")";
		$query = $this->query($queryString);
		$counter = $this->getCount($query);
		for($i=1; $i<=$counter; $i++)
		{
			$_SESSION['orderIdent'][$i] = $this->getrow($query);
		}
		$_SESSION['identifyOrdersResult']= $counter;
	} elseif($action=="count") {
		$_SESSION['countOrders'] = $this->getrow($this->query("SELECT sum(".ROSTER_ADDON_ORDERSTABLE.".reserved_quantity) as items_taken FROM ".ROSTER_ADDON_ORDERSTABLE." WHERE ('".$this->escape($comparison)."' = ".ROSTER_ADDON_ORDERSTABLE.".item_name)"));
	}
}


function orderItem()
{
	if(empty($_SESSION['UserName'])) return;
	$MemberID = $this->getrow($this->query("SELECT member_id FROM ".ROSTER_MEMBERSTABLE." WHERE name='".$_SESSION['UserName']."'"));
	if ($MemberID == "") {
		die ($MemberID);
	}
	if ((isset($_REQUEST['itemName'], $_REQUEST['treasurerID'])) && ($_REQUEST['itemName']!= "" && $_REQUEST['treasurerID']!= "" ))
	{
		if((isset($_REQUEST['quantity'])) && ($_REQUEST['quantity']!=""))
		{
			$this->query("INSERT INTO ".ROSTER_ADDON_ORDERSTABLE." (item_name, reserved_quantity, member_id, treasurer_id) VALUES ('".urldecode($_REQUEST['itemName'])."', ".intval($_REQUEST['quantity']).", ".$MemberID['member_id'].", ".intval($_REQUEST['treasurerID']).")");
		}
		$this->refreshPage();
	}
}


function updateURLforInsert($itemName, $treasurerID){
$queryString_insertSQL = "&itemName=$itemName&treasurerID=$treasurerID";
return $queryString_insertSQL;
}


function generateSearchString()
{// See if the search function was used
	if((!isset($_COOKIE['search_query_string'])) && (!isset($_COOKIE['item_color'])) && (!isset($_COOKIE['select_treasurer'])) && (isset($_REQUEST['searchform'])) && ($_REQUEST['searchform']!="" && $_REQUEST['searchform']!=="clear"))
	{//print "Get the item name if it has been entered";
		if(isset($_REQUEST['item_name_field'])&& ($_REQUEST['item_name_field']!="")) $_SESSION['search_query_string'] = '+('.urldecode($_REQUEST['item_name_field']).') ';
		
		if(isset($_REQUEST['lvl_range_from']) && ($_REQUEST['lvl_range_from']!="") || isset($_REQUEST['lvl_range_to']) && ($_REQUEST['lvl_range_to']!="")) $_SESSION['search_query_string'] .= '+(';
		if(isset($_REQUEST['lvl_range_from']) && ($_REQUEST['lvl_range_from']!="") && ($_REQUEST['lvl_range_to']=="")) 
		{//print "If only the level from field was used, assume its the minimum level setting and display everything up to 60";
			if(intval($_REQUEST['lvl_range_from'])<60) 
			{
				for($i=intval($_REQUEST['lvl_range_from']); $i<=60; $i++)
				{
					$_SESSION['search_query_string'] = $_SESSION['search_query_string'].'"Level '.$i.'" ';
				}
			} else {
				$_SESSION['search_query_string'] = $_SESSION['search_query_string'].'"Level 60" ';
			}
		}
		if(isset($_REQUEST['lvl_range_to']) && ($_REQUEST['lvl_range_to']!="") && ($_REQUEST['lvl_range_from']=="")) 
		{// If only the level to field was used, assume its the maximum level setting and display everything below that level
			$level = intval($_REQUEST['lvl_range_to']);
			if($level>60) { $level = 60; } else 
			{
				for($i=$level; $i>=1; $i--)
				{
					$_SESSION['search_query_string'] = $_SESSION['search_query_string'].'"Level '.$i.'" ';
				}
			}
		}
		if(isset($_REQUEST['lvl_range_from'], $_REQUEST['lvl_range_to']) && ($_REQUEST['lvl_range_from']!="" && $_REQUEST['lvl_range_to']!="")) 
		{// If both fields were used, see if its valid input, then compare them to make sure miniumum is not bigger than maximum, then display everything in between, inclusive
			$level_from = intval($_REQUEST['lvl_range_from']);
			$level_to = intval($_REQUEST['lvl_range_to']);
			if($level_from < 1) $level_from = 1;
			if($level_from > 60) $level_from = 60;
			if($level_to < $level_from) $level_to = $level_from;
			if($level_to > 60) $level_to = 60;
			for($i=$level_from; $i<=$level_to; $i++)
			{
				$_SESSION['search_query_string'] = $_SESSION['search_query_string'].'"Level '.$i.'" ';
			}
		}
		if((isset($_REQUEST['rarity'])) && ($_REQUEST['rarity']!=""))
		{// If the rarity of the items has been selected, get that value
			if($_REQUEST['rarity']!=="select") {
				$_SESSION['item_color'] = $_REQUEST['rarity'];
			}
		}
		if(isset($_REQUEST['lvl_range_from']) && ($_REQUEST['lvl_range_from']!="") || isset($_REQUEST['lvl_range_to']) && ($_REQUEST['lvl_range_to']!="")) $_SESSION['search_query_string'] .= ')';
		
		// Item Type
		if((isset($_REQUEST['item_type'])) && ($_REQUEST['item_type']!=""))
		{
			if($_REQUEST['item_type']!=="select") { 
				$_SESSION['search_query_string'] .= '+('.stripslashes($_REQUEST['item_type']).')';
			}
		}
		
		setcookie("search_query_string", $_SESSION['search_query_string']);
		setcookie("item_color", $_SESSION['item_color']);
		setcookie("select_treasurer", $_REQUEST['select_treasurer']);
		$this->refreshPage();
	} elseif($_REQUEST['searchform']=="clear") {// Clear out all search session variables and delete the cookies
		unset($_SESSION['search_query_string'], $_SESSION['item_color'], $_REQUEST['searchform']);
		setcookie("search_query_string", "", time() - 3600);
		setcookie("item_color", "", time() - 3600);
		setcookie("select_treasurer", "", time() - 3600);
		$this->refreshPage();
	}
}


function resetUser(){
	if(isset($_REQUEST['ResetUser'])){
		global $Authentication;

		//$Authentication->deleteCookie();
		$this->refreshPage(); 
	}
}


function refreshPage(){
$refresh = dirname('http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'])."/modules.php?name=roster&op=addon&roster_addon_name=treasurySystem&username=".$_SESSION['UserName']."&pageNum_Recordset2=".$_REQUEST['pageNum_Recordset2']."";
header ('Location:'.$refresh);
exit();
}


function updateURLforDelete($order_id_to_delete){
$queryString_deleteSQL = NULL;
$queryString_deleteSQL = sprintf("&order_id_delete=%d", $order_id_to_delete);
return $queryString_deleteSQL;
}


function deleteOrder()
{
	if ((isset($_REQUEST['order_id_delete'])) && ($_REQUEST['order_id_delete'] != "")) 
	{
		$this->query("DELETE FROM ".ROSTER_ADDON_ORDERSTABLE." WHERE order_id=".$_REQUEST['order_id_delete']."");
		$this->refreshPage();
	} elseif ((isset($cleanOrdersArray['order_id'])) && ($cleanOrdersArray['order_id']!=""))
	{
		$this->query("DELETE FROM ".ROSTER_ADDON_ORDERSTABLE." WHERE order_id=".$cleanOrdersArray['order_id']."");
	}
}


function recordSets()
{
// Check if the treasury is configured propperly.
	if(empty($_SESSION['fieldName'])) {
		print "Please configure the Treasury addon.";
		die();
	}
	
$maxRows_Recordset = $_SESSION['itemsPerPage'];
$pageNum_Recordset = 0;
	if (isset($_REQUEST['pageNum_Recordset2'])) 
	{
	  	$pageNum_Recordset = $_REQUEST['pageNum_Recordset2'];
	}
$startRow_Recordset = $pageNum_Recordset * $maxRows_Recordset;

$row_Recordset2 = array();
$row_Recordset1 = array();

// get the items of each treasurer separately to avoid duplicates
$queryString = "SELECT member_id, name FROM ".ROSTER_MEMBERSTABLE." WHERE ".$_SESSION['fieldName']." LIKE '%".$_SESSION['bankerRankName']."%'";
$query = $this->query($queryString);
$treasuersCount = $this->getCount($query);

for($j=1; $j<=$treasuersCount; $j++){
	$treasurers = $this->getrow($query);
	
	$_SESSION['treasurerNames'][$j] = $treasurers['name'];
	
	// Start query string
		$query_Recordset2 = "SELECT ".ROSTER_MEMBERSTABLE.".member_id, ".ROSTER_MEMBERSTABLE.".name, ".ROSTER_MEMBERSTABLE.".guild_title, ".ROSTER_ITEMSTABLE.".* FROM ".ROSTER_MEMBERSTABLE.", ".ROSTER_ITEMSTABLE." WHERE ".ROSTER_MEMBERSTABLE.".member_id=".ROSTER_ITEMSTABLE.".member_id and ".ROSTER_MEMBERSTABLE.".member_id=".$treasurers['member_id']." and ".ROSTER_ITEMSTABLE.".item_parent!='bags' and ".ROSTER_ITEMSTABLE.".item_parent!='equip' and ".ROSTER_ITEMSTABLE.".item_tooltip not like '%Soulbound%'";
		$query_Recordset1 = "SELECT ".ROSTER_MEMBERSTABLE.".member_id, ".ROSTER_MEMBERSTABLE.".guild_title, ".ROSTER_ITEMSTABLE.".item_name, ".ROSTER_ITEMSTABLE.".item_parent, ".ROSTER_ITEMSTABLE.".item_tooltip, sum(".ROSTER_ITEMSTABLE.".item_quantity) as total_quantity FROM ".ROSTER_MEMBERSTABLE.", ".ROSTER_ITEMSTABLE." WHERE ".ROSTER_MEMBERSTABLE.".member_id=".ROSTER_ITEMSTABLE.".member_id and ".ROSTER_MEMBERSTABLE.".member_id=".$treasurers['member_id']." and ".ROSTER_ITEMSTABLE.".item_parent!='bags' and ".ROSTER_ITEMSTABLE.".item_parent!='equip' and ".ROSTER_ITEMSTABLE.".item_tooltip not like '%Soulbound%'";
	
	if((isset($_COOKIE['search_query_string']) && ($_COOKIE['search_query_string']!="")))
	{// Add text input search criteria
		$query_Recordset2 .= " and match (item_name,item_tooltip) against ('".$_COOKIE['search_query_string']."' IN BOOLEAN MODE)";
		$query_Recordset1 .= " and match (item_name,item_tooltip) against ('".$_COOKIE['search_query_string']."' IN BOOLEAN MODE)";
	}
	if(isset($_COOKIE['select_treasurer']) && $_COOKIE['select_treasurer']!="" && $_COOKIE['select_treasurer']!=="select")
	{// Add treasurer selection criterion
		$query_Recordset2 .= " and ".ROSTER_MEMBERSTABLE.".name='".$this->escape($_COOKIE['select_treasurer'])."'";
		$query_Recordset1 .= " and ".ROSTER_MEMBERSTABLE.".name='".$this->escape($_COOKIE['select_treasurer'])."'";
	}
	if(isset($_COOKIE['item_color']) && $_COOKIE['item_color']!=="")
	{// Only rarity
		$query_Recordset2 .= " and item_color='".$_COOKIE['item_color']."'";
		$query_Recordset1 .= " and item_color='".$_COOKIE['item_color']."'";
	} 
	// Finish the query string
		$query_Recordset2 .= " group by ".ROSTER_ITEMSTABLE.".item_name";
		$query_Recordset1 .= " group by ".ROSTER_ITEMSTABLE.".item_name";
	
	
	$Recordset = $this->query($query_Recordset2);
	for($i=1; $i<=$this->getCount($Recordset); $i++)
	{
		$row_Recordset2temp[$i] = $this->getrow($Recordset);
	}
	if(!empty($row_Recordset2temp[1])) $row_Recordset2 = array_merge_recursive($row_Recordset2temp, $row_Recordset2);
	
	$Recordset = $this->query($query_Recordset1);
	for($i=1; $i<=$this->getCount($Recordset); $i++)
	{
		$row_Recordset1temp[$i] = $this->getrow($Recordset);
	}
	if(!empty($row_Recordset1temp[1])) $row_Recordset1 = array_merge_recursive($row_Recordset1temp, $row_Recordset1);

}


// Change sorting from treasurer name to item name
foreach($row_Recordset2 as $key => $value){
	$i++;
	if(!empty($value)){
		foreach($value as $key => $values){
			if($key == 'item_name') $item_names[$i] = $values;
		}
	}
}
foreach($row_Recordset1 as $key => $value){
	$i++;
	if(!empty($value)){
		foreach($value as $key => $values){
			if($key == 'item_name') $item_count[$i] = $values;
		}
	}
}
@array_multisort($row_Recordset2,SORT_DESC,SORT_STRING,$item_names,SORT_ASC,SORT_STRING);
@array_multisort($row_Recordset1,SORT_DESC,SORT_STRING,$item_count,SORT_ASC,SORT_STRING);


// Clean the array
for($i=0; $i<=count($row_Recordset2); $i++){
	$temp_row[$i] = $row_Recordset2[$i];
}
foreach ($temp_row as $key => $value) {
   $temp_row[$key] = serialize($value);
}
$temp_row = array_unique($temp_row);
foreach ($temp_row as $key => $value) {
   $temp_row[$key] = unserialize($value);
}

$row_Recordset2 = array_values($temp_row);
array_unshift($row_Recordset2, " ");

$_SESSION['totalRowsRecordset'] = count($temp_row);
$totalRows_Recordset = count($temp_row);

for($i=0; $i<=count($row_Recordset1); $i++){
	$temp_row[$i] = $row_Recordset1[$i];
	array_unique($temp_row);
}
foreach ($temp_row as $key => $value) {
   $temp_row[$key] = serialize($value);
}
$temp_row = array_unique($temp_row);
foreach ($temp_row as $key => $value) {
   $temp_row[$key] = unserialize($value);
}

$row_Recordset1 = array_values($temp_row);
array_unshift($row_Recordset1, " ");


$totalPages_Recordset = ceil($totalRows_Recordset/$maxRows_Recordset)-1;

$queryString_Recordset = "";
	if (!empty($_SERVER['QUERY_STRING'])) 
	{
		$params = explode("&", $_SERVER['QUERY_STRING']);
		$newParams = array();
		foreach ($params as $param) 
		{
			if (stristr($param, "pageNum_Recordset2") == false && stristr($param, "totalRows_Recordset2") == false) 
			{
				array_push($newParams, $param);
			}
	  	}
			if (count($newParams) != 0) 
			{
				$queryString_Recordset = "&" . htmlentities(implode("&", $newParams));
			}
	}
$queryString_Recordset = sprintf("&totalRows_Recordset2=%d%s", $totalRows_Recordset, $queryString_Recordset);


$returnedRecordSets = array();
$returnedRecordSets[0] = $row_Recordset2;
$returnedRecordSets[1] = $row_Recordset1;
$returnedRecordSets[2] = $queryString_Recordset;
$returnedRecordSets[3] = $pageNum_Recordset;
$returnedRecordSets[4] = $totalPages_Recordset;
$returnedRecordSets[5] = $totalRowsRecordset;

$_SESSION['RecordSetArray'] = $returnedRecordSets;
}


function URLextensions()
{
	foreach ($_SESSION['RecordSetArray'] as $key => $value)
	{
		if($key == 2){ $_SESSION['queryString_Recordset2'] = str_replace("&roster_addon_name=treasurySystem", "", $value);}
		if($key == 3){ $_SESSION['pageNum_Recordset'] = $value;}
		if($key == 4){ $_SESSION['totalPages_Recordset'] = $value;}
	}
}


function superUser($treasurerName)
{
//	return true;
	if($treasurerName!=="dummyValue")
	{
		$_SESSION['UserName'] = $treasurerName;
	}
	$this->settings();
	foreach($_SESSION['superUsers'] as $key => $value)
	{
		if($_SESSION['UserName']==$value) {
			return true;
		} else {
			$_SESSION['superUser'] = array();
			unset($_SESSION['superUser']);
		}
	}
}


function makeHistory()
{
$queryString = "SELECT DISTINCT ".ROSTER_ADDON_ORDERSTABLE.".item_name, ".ROSTER_ADDON_ORDERSTABLE.".order_history FROM ".ROSTER_ADDON_ORDERSTABLE."  LEFT JOIN  ".ROSTER_ITEMSTABLE." ON ".ROSTER_ADDON_ORDERSTABLE.".item_name = ".ROSTER_ITEMSTABLE.".item_name WHERE ".ROSTER_ITEMSTABLE.".item_name is NULL";
$query = $this->query($queryString);
$counter = $this->getCount($query);
	if($counter>=1)
	{
		for($i=1; $i<=$counter; $i++)
		{
			$cleanOrdersArray = $this->getrow($query);
			if($cleanOrdersArray['order_history']=="0000-00-00 00:00:00")
			{
				$this->query("UPDATE ".ROSTER_ADDON_ORDERSTABLE." SET order_history = NOW() WHERE (item_name = '".$this->escape($cleanOrdersArray['item_name'])."')");
			}
		}
	}
}


function getPrice($item_name, $total_quantity, $reserved_quantity)
{
	$getPriceArray = $this->getrow($this->query("SELECT ".ROSTER_ADDON_ITEMSPRICETABLE.".* FROM ".ROSTER_ADDON_ITEMSPRICETABLE." WHERE ".ROSTER_ADDON_ITEMSPRICETABLE.".item_name = '".$this->escape($item_name)."'"));
	if($getPriceArray['type']=="Gold")
	{
		if($total_quantity!=="dummyValue")
		{
			$money[0] = intval($getPriceArray['price']/10000);
			$money[1] = intval($getPriceArray['price']/100-$money[0]*100);
			$money[2] = intval($getPriceArray['price']-$money[0]*10000-$money[1]*100);
			$money[3] = $getPriceArray['type'];
			$money[4] = $getPriceArray['stack_size'];

			if($reserved_quantity=="dummyValue")
			{
				if($money[0]!==0){print "<span style='color: #FFE25B'>".$money[0]."</span><img src='modules/roster/img/bagcoingold.gif' /> ";} 
				if($money[1]!==0){print "<span style='color: #E7E7E7'>".$money[1]."</span><img src='modules/roster/img/bagcoinsilver.gif' /> ";} 
				if($money[2]!==0){print "<span style='color: #C5922D'>".$money[2]."</span><img src='modules/roster/img/bagcoinbronze.gif' />";}
				if($total_quantity>1)
				{ 
					if($getPriceArray['stack_size']==1 && $getPriceArray['price']!=0)
					{
						print "<br><span style='color: #E7E7E7'>per item</span>";
					} elseif($getPriceArray['price']!=0) {
						print "<br><span style='color: #E7E7E7'>per stack of ".$getPriceArray['stack_size']."</span>";
					}
				}
			}
		} else {
			$totalCost = $reserved_quantity/$getPriceArray['stack_size']*$getPriceArray['price'];
			$money[0] = intval($totalCost/10000);
			$money[1] = intval($totalCost/100-$money[0]*100);
			$money[2] = intval($totalCost-$money[0]*10000-$money[1]*100);
			if($money[0]!==0){print "<span style='color: #FFE25B'>".$money[0]."</span><img src='modules/roster/img/bagcoingold.gif' /> ";} 
			if($money[1]!==0){print "<span style='color: #E7E7E7'>".$money[1]."</span><img src='modules/roster/img/bagcoinsilver.gif' /> ";} 
			if($money[2]!==0){print "<span style='color: #C5922D'>".$money[2]."</span><img src='modules/roster/img/bagcoinbronze.gif' />";}
		}
	}
	if($getPriceArray['type']=="DKP")
	{
		if($total_quantity!=="dummyValue")
		{
			if($reserved_quantity!=="dummyValue")
			{
				$money[2] = $getPriceArray['price'];
				$money[3] = $getPriceArray['type'];
			} elseif($getPriceArray['price']!=0) {
				print "<span style='color: #E7E7E7'>".$getPriceArray['price']." DKP</span>";
			}
		} else {
			$totalCost = $reserved_quantity/$getPriceArray['stack_size']*$getPriceArray['price'];
			print "<span style='color: #E7E7E7'>".$totalCost." DKP</span>";
		}
	}
	if($money!=NULL){
	$_SESSION['money'] = $money;
	}
}


function setPrice()
{
	if((isset($_REQUEST['setOrGet']))&&($_REQUEST['setOrGet']=="set")) 
	{
		$checkSetPriceCount = $this->getCount($this->query("SELECT ".ROSTER_ADDON_ITEMSPRICETABLE.".item_name FROM  ".ROSTER_ADDON_ITEMSPRICETABLE." WHERE ".ROSTER_ADDON_ITEMSPRICETABLE.".item_name = '".mysql_real_escape_string(base64_decode($_REQUEST['itemName']))."'"));
		
		$temp_price[0] = $_REQUEST['gold']*10000;
		$temp_price[1] = $_REQUEST['silver']*100;
		$temp_price[2] = $_REQUEST['copper'];
		$price = array_sum($temp_price);
		if($_REQUEST['type']=="DKP"){$price = $_REQUEST['DKP'];}
		
		if($checkSetPriceCount!==1)
		{
			$this->query("INSERT INTO ".ROSTER_ADDON_ITEMSPRICETABLE." (item_name, stack_size, price, type) VALUES ('".$this->escape(base64_decode($_REQUEST['itemName']))."', '".intval($_REQUEST['stack_size'])."', $price, '".$_REQUEST['type']."')");
			$this->refreshPage();
		} else {
			$this->query("UPDATE ".ROSTER_ADDON_ITEMSPRICETABLE." SET item_name='".$this->escape(base64_decode($_REQUEST['itemName']))."', stack_size=".intval($_REQUEST['stack_size']).", price=$price, type='".$_REQUEST['type']."' WHERE ".ROSTER_ADDON_ITEMSPRICETABLE.".item_name = '".$this->escape(base64_decode($_REQUEST['itemName']))."'");
			$this->refreshPage();
		}
	}
}


function UUreportNoteIt($treasurerName)
{
	$treasurerNames = explode(",", $treasurerName);
	foreach($treasurerNames as $treasurerName)
	{
		$treasurerName = ucfirst(strtolower($treasurerName));
		$treasurerID = $this->getrow($this->query("SELECT ".ROSTER_MEMBERSTABLE.".member_id FROM ".ROSTER_MEMBERSTABLE." WHERE ".ROSTER_MEMBERSTABLE.".name = '".$treasurerName."'"));
		$queryString = "SELECT DISTINCT ".ROSTER_ADDON_ORDERSTABLE.".*, ".ROSTER_ADDON_ITEMSPRICETABLE.".stack_size, ".ROSTER_ADDON_ITEMSPRICETABLE.".price, ".ROSTER_ADDON_ITEMSPRICETABLE.".type, ".ROSTER_MEMBERSTABLE.".name FROM ".ROSTER_ADDON_ORDERSTABLE.", ".ROSTER_ITEMSTABLE.", ".ROSTER_MEMBERSTABLE." LEFT JOIN ".ROSTER_ADDON_ITEMSPRICETABLE." ON ".ROSTER_ADDON_ORDERSTABLE.".item_name = ".ROSTER_ADDON_ITEMSPRICETABLE.".item_name WHERE ".ROSTER_ADDON_ORDERSTABLE.".item_name = ".ROSTER_ITEMSTABLE.".item_name AND ".ROSTER_ADDON_ORDERSTABLE.".member_id = ".ROSTER_MEMBERSTABLE.".member_id AND ".ROSTER_ITEMSTABLE.".member_id = ".ROSTER_ADDON_ORDERSTABLE.".treasurer_id AND ".ROSTER_ADDON_ORDERSTABLE.".treasurer_id = '".$treasurerID['member_id']."' ORDER BY ".ROSTER_ADDON_ORDERSTABLE.".item_name ASC";
		$query = $this->query($queryString);
		$counter = $this->getCount($query);
		if($counter!==0 && !$printed)
		{
			for($i=1; $i<=$counter; $i++)
			{
				$UUreportNoteItArray[$i] = $this->getrow($query);
			}
		
			// Authenticate
			if($this->superUser($treasurerName)) {
		
				// Count stuff
				for($l=1; $l<=$counter; $l++)
				{
					$allItemNames[$l] = $UUreportNoteItArray[$l]['item_name'];
				}
				
				for($k=1; $k<=$counter; $k++)
				{	
					// Is this a multi-item multi-person order, how many orders?
					$num = count(array_keys($allItemNames, $UUreportNoteItArray[$k]['item_name']));
					if($this->firstOne!=="firstOne"){
					$this->counterUU=$num;
					}
					// Once off stuff
					if($this->first!=="printed") 
					{ 
						print $firstString = 'noteIt = {';
						$this->first = "printed"; 
					}		
					// If there is currency involved
					if((intval($UUreportNoteItArray[$k]['price'])!==0)&&($UUreportNoteItArray[$k]['type']=="Gold")||($UUreportNoteItArray[$k]['type']=="DKP"))
					{
						if($UUreportNoteItArray[$k]['type'] == "Gold"){
							// Calculate money
							$totalCost = intval($UUreportNoteItArray[$k]['reserved_quantity'])/intval($UUreportNoteItArray[$k]['stack_size'])*intval($UUreportNoteItArray[$k]['price']);
							$money[0] = intval($totalCost/10000);
							$money[1] = intval($totalCost/100-$money[0]*100);
							$money[2] = intval($totalCost-$money[0]*10000-$money[1]*100);
							// Format money
							if($money[0]>0&&$money[1]>0&&$money[2]>0){$moneyString = sprintf("%sg %ss %sc", $money[0], $money[1], $money[2]);}else //g, s, c
							if($money[1]>0&&$money[2]>0){$moneyString = sprintf("%ss %sc", $money[1], $money[2]);}else //s, c
							if($money[2]>0){$moneyString = sprintf("%sc", $money[2]);}else //c
							if($money[0]>0&&$money[1]>0){$moneyString = sprintf("%sg %ss", $money[0], $money[1]);}else //g, s
							if($money[0]>0&&$money[2]>0){$moneyString = sprintf("%sg %sc", $money[0], $money[2]);}else //g, c
							if($money[1]>0){$moneyString = sprintf("%ss", $money[1]);} //s
						} elseif($UUreportNoteItArray[$k]['type'] == "DKP") {
							$moneyString = sprintf("%s DKP", $UUreportNoteItArray[$k]['price']);
						}
						// Print it all, considering all possible scenarios
						if($num>1)
						{
							if($this->firstOne!=="firstOne"){
								print $dynamicString[$k] = sprintf(' ["%s"] = { [1] = "Ordered by: %s \ Quantity: %s \ Cost: %s \ \ ', $UUreportNoteItArray[$k]['item_name'], $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity'], $moneyString);
								$this->firstOne="firstOne";
								$this->counterUU--; 
							} elseif($this->counterUU>1) {
								print $dynamicString[$k] = sprintf('Ordered by: %s \ Quantity: %s \ Cost: %s \ \ ',  $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity'], $moneyString);
								$this->counterUU--;
							}elseif($this->counterUU==1) {
								print $dynamicString[$k] = sprintf('Ordered by: %s \ Quantity: %s \ Cost: %s",   [2] = "%s",   [3] = "%s",  }, ', $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity'], $moneyString, $treasurerName, $_SESSION['serverName']);
								$this->firstOne="";
							}
						} else {
							print $dynamicString[$k] = sprintf(' ["%s"] = {   [1] = "Ordered by: %s \ Quantity: %s \ Cost: %s",   [2] = "%s",   [3] = "%s",  }, ', $UUreportNoteItArray[$k]['item_name'], $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity'], $moneyString, $treasurerName, $_SESSION['serverName']);
						}
					} else{
						if($num>1)
						{
							if($this->firstOne!=="firstOne"){
								print $dynamicString[$k] = sprintf(' ["%s"] = { [1] = "Ordered by: %s \ Quantity: %s \ \ ', $UUreportNoteItArray[$k]['item_name'], $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity']);
								$this->firstOne="firstOne";
								$this->counterUU--; 
							} elseif($this->counterUU>1) {
								print $dynamicString[$k] = sprintf('Ordered by: %s \ Quantity: %s \ \ ',  $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity']);
								$this->counterUU--;
							}elseif($this->counterUU==1) {
								print $dynamicString[$k] = sprintf('Ordered by: %s \ Quantity: %s",   [2] = "%s",   [3] = "%s",  }, ', $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity'], $treasurerName, $_SESSION['serverName']);
								$this->firstOne="";
							}
						} else {
							print $dynamicString[$k] = sprintf(' ["%s"] = {   [1] = "Ordered by: %s \ Quantity: %s",   [2] = "%s",   [3] = "%s",  }, ', $UUreportNoteItArray[$k]['item_name'], $UUreportNoteItArray[$k]['name'], $UUreportNoteItArray[$k]['reserved_quantity'],$treasurerName, $_SESSION['serverName']);
						}
					}
				}
			}
		}else{
			print 'noteIt = { 
			}
			noteItColour = { 
				["b"] = 1, 
				["g"] = 0.8, 
				["r"] = 0, 
			} 
			noteItMode = 1 
			noteItSplash = true 
			noteItAddGuild = true 
			noteItPlaySound = false';
			$printed = 1;
		}
	}
	// Append the config section of the NoteIt.lua so we can replace the whole file
	print $lastString = '} 
	noteItColour = { 
		["b"] = 1, 
		["g"] = 0.8, 
		["r"] = 0, 
	} 
	noteItMode = 1 
	noteItSplash = true 
	noteItAddGuild = true 
	noteItPlaySound = false  ';
}


function totalOrdersCost()
{
	$queryString = "SELECT DISTINCT ".ROSTER_ADDON_ORDERSTABLE.".*, ".ROSTER_ADDON_ITEMSPRICETABLE.".stack_size, ".ROSTER_ADDON_ITEMSPRICETABLE.".price, ".ROSTER_ADDON_ITEMSPRICETABLE.".type FROM ".ROSTER_ADDON_ORDERSTABLE.", ".ROSTER_ADDON_ITEMSPRICETABLE." LEFT JOIN ".ROSTER_MEMBERSTABLE." ON ".ROSTER_ADDON_ORDERSTABLE.".member_id = ".ROSTER_MEMBERSTABLE.".member_id  WHERE ".ROSTER_ADDON_ORDERSTABLE.".order_history = '0000-00-00 00:00:00'  AND ".ROSTER_ADDON_ORDERSTABLE.".item_name = ".ROSTER_ADDON_ITEMSPRICETABLE.".item_name AND ".ROSTER_MEMBERSTABLE.".name = '".$_SESSION['UserName']."'";
	$query = $this->query($queryString);
	$counter = $this->getCount($query);
	if($counter!==0){
		for($i=1; $i<=$counter; $i++)
		{
			$totalOrdersCostArray[$i] = $this->getrow($query);
		}
		foreach($totalOrdersCostArray as $key => $value)
		{
			if($value['type'] == "Gold") {
				$totalOrdersGoldCost += intval($value['reserved_quantity'])/intval($value['stack_size'])*intval($value['price']);
			} elseif($value['type'] == "DKP") {
				$totalOrdersDKPCost += intval($value['reserved_quantity'])/intval($value['stack_size'])*intval($value['price']);
			}
		}
		if($totalOrdersGoldCost!=""){
			$money[0] = intval($totalOrdersGoldCost/10000);
			$money[1] = intval($totalOrdersGoldCost/100-$money[0]*100);
			$money[2] = intval($totalOrdersGoldCost-$money[0]*10000-$money[1]*100);
			// Format money
			if($money[0]>0&&$money[1]>0&&$money[2]>0){$moneyString = sprintf("<span style='color: #FFE25B'>%s</span><img src='modules/roster/img/bagcoingold.gif' /> <span style='color: #E7E7E7'>%s</span><img src='modules/roster/img/bagcoinsilver.gif' /> <span style='color: #C5922D'>%s</span><img src='modules/roster/img/bagcoinbronze.gif' />", $money[0], $money[1], $money[2]);}else //g, s, c
			if($money[0]>0&&$money[1]>0){$moneyString = sprintf("<span style='color: #FFE25B'>%s</span><img src='modules/roster/img/bagcoingold.gif' /> <span style='color: #E7E7E7'>%s</span><img src='modules/roster/img/bagcoinsilver.gif' /> ", $money[0], $money[1]);}else //g, s
			if($money[0]>0&&$money[2]>0){$moneyString = sprintf("<span style='color: #FFE25B'>%s</span><img src='modules/roster/img/bagcoingold.gif' />  <span style='color: #C5922D'>%s</span><img src='modules/roster/img/bagcoinbronze.gif' />", $money[0], $money[2]);}else //g, c
			if($money[1]>0&&$money[2]>0){$moneyString = sprintf("<span style='color: #E7E7E7'>%s</span><img src='modules/roster/img/bagcoinsilver.gif' />  <span style='color: #C5922D'>%s</span><img src='modules/roster/img/bagcoinbronze.gif' />", $money[1], $money[2]);}else //s, c
			if($money[0]>0){$moneyString = sprintf("<span style='color: #FFE25B'>%s</span><img src='modules/roster/img/bagcoingold.gif' />", $money[0]);}else //g
			if($money[1]>0){$moneyString = sprintf("<span style='color: #E7E7E7'>%s</span><img src='modules/roster/img/bagcoinsilver.gif' /> ", $money[1]);}else //s
			if($money[2]>0){$moneyString = sprintf("<span style='color: #C5922D'>%s</span><img src='modules/roster/img/bagcoinbronze.gif' />", $money[2]);} //c
			print $moneyString;
		}
		if($totalOrdersDKPCost!=""){
			print " DKP: ".$totalOrdersDKPCost."";
		}
	}
}


function pageNumbering()
{
	if($_REQUEST['totalRows_Recordset2'] < 1) { $totalRows = $_SESSION['totalRowsRecordset']; } else { $totalRows = $_REQUEST['totalRows_Recordset2']; }
	$_SESSION['pageNumbers'] = ceil($totalRows/$_SESSION['itemsPerPage'])-1;
	for($i=0; $i<=$_SESSION['pageNumbers']; $i++)
	{
		if($_REQUEST['pageNum_Recordset2'] == $i) { 
			print "<a href=".dirname('http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'])."/modules.php?name=roster&op=addon&roster_addon_name=treasurySystem&username=".$_SESSION['UserName']."&pageNum_Recordset2=".$i."><font style='color:#FFFFFF;'>".($i+1)."</font> </a>"; 
		} else {
			print "<a href=".dirname('http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'])."/modules.php?name=roster&op=addon&roster_addon_name=treasurySystem&username=".$_SESSION['UserName']."&pageNum_Recordset2=".$i.">".($i+1)." </a>";
		}
	}
}


function loanSystemExists()
{
	if(@file_exists('modules/roster/addons/loanSystem/addon_config.php'))return true;
}


function settings()
{
	if (isset($_REQUEST['pwdfield']))
	{ 
			$_SESSION['admin_logged_in'] = 1;
	}
	
		if (!isset($_SESSION['fieldName'])){
			@extract($this->getrow($this->query("SELECT * FROM ".ROSTER_ADDON_TREASURYSETTINGSTABLE."")));
			$_SESSION['fieldName'] = $field_name;
			$_SESSION['bankerRankName'] = $identification_tag;
			$_SESSION['itemsPerPage'] = $items_per_page;
			$_SESSION['Price']['Status'] = $price_status;
			if($super_users)$_SESSION['superUsers'] = explode(",", $super_users);

			$queryString = "SELECT ".ROSTER_MEMBERSTABLE.".name FROM ".ROSTER_MEMBERSTABLE."";
			$query = $this->query($queryString);
			$count = $this->getCount($query);
			for($i=1; $i<=$count; $i++){
				$_SESSION['membersList'][$i] = $this->getrow($query);
			}
			if($members_only == 'off') $_SESSION['membersOnly'] = NULL;
			else $_SESSION['membersOnly'] = $members_only;
		}
}


function showOrders()
{
	$this->getOrders();
	$showOrdersArray = $_SESSION['orders'];
	for($i=1; $i<=count($showOrdersArray); $i++){
		foreach($showOrdersArray[$i] as $key => $value){
			if($key == 'item_name'){ 
				$itemIcon = $this->getrow($this->query("SELECT DISTINCT item_texture, item_color FROM ".ROSTER_ITEMSTABLE." WHERE item_name = '".$this->escape($value)."'"));
				$showOrdersArray[$i]['item_icon'] = $itemIcon['item_texture'];
				$showOrdersArray[$i]['item_color'] = ltrim($itemIcon['item_color'], "ff");
				$priced = $this->getrow($this->query("SELECT price FROM ".ROSTER_ADDON_ITEMSPRICETABLE." WHERE item_name = '".$this->escape($value)."'"));
			}
			if($key == 'treasurer_id'){
				$memberName = $this->getrow($this->query("SELECT name FROM ".ROSTER_MEMBERSTABLE." WHERE member_id = ".$value.""));
				$showOrdersArray[$i]['treasurer_name'] = $memberName['name'];
			}
			if(!empty($priced)){
				ob_start();
				$this->getPrice($showOrdersArray[$i]['item_name'], "dummyValue", $showOrdersArray[$i]['reserved_quantity']);
				$showOrdersArray[$i]['item_price'] = ob_get_contents();
				ob_end_clean();
			}
			$priced = NULL;
		}
	}
	return $showOrdersArray;
}



// debuging function
function print_array($arr, $level) {
	$indent=str_repeat("&nbsp;", $level * 4);
	print "<div align='left'>";
	foreach ($arr as $key => $item) {
		if (is_array($item)) {
			print $indent . "[".$key."] Item is an array...<br><br>";
			$this->print_array($item, $level + 1);
		} else
			print $indent . $key .": ". $item . "<br><br>";
	}
	print "</div>";
}


}//end of class
?>